# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'


%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/apache-modeler/2.0-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define base_name modeler
%define short_name commons-%{base_name}

Name: jakarta-%{short_name}
Epoch: 0
Version: 2.0
Release: 3jpp_2rh
Summary: Jakarta Commons Modeler Package
Group: Development/Libraries/Java
License: Apache Software License
Url: http://jakarta.apache.org/commons/%{base_name}
Source0: %{short_name}-%{version}-src.tar.gz
Patch0: %{name}.build.properties.default.patch
Patch1: %{name}.build.xml.patch
Source1:	jakarta-commons-modeler-component-info.xml
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%if %{gcj_support}
BuildRequires: java-gcj-compat-devel
Requires(post): java-gcj-compat
Requires(postun): java-gcj-compat
%endif
BuildRequires: ant
BuildRequires: findutils
BuildRequires: jakarta-commons-beanutils >= 0:1.3
BuildRequires: jakarta-commons-collections >= 0:2.0
BuildRequires: jakarta-commons-digester >= 0:1.2
BuildRequires: jakarta-commons-logging >= 0:1.0
BuildRequires: jaxp_parser_impl
BuildRequires: jaxp_transform_impl
BuildRequires: jmxri
BuildRequires: junit >= 0:3.7
BuildRequires: xml-commons-apis >= 1.3
Requires: jakarta-commons-beanutils >= 0:1.3
Requires: jakarta-commons-collections >= 0:2.0
Requires: jakarta-commons-digester >= 0:1.2
Requires: jakarta-commons-logging >= 0:1.0
Requires: jaxp_parser_impl
Requires: jaxp_transform_impl
Requires: jmxri
Requires: xml-commons-apis
%if ! %{gcj_support}
BuildArch: noarch
%endif
Provides: %{short_name} = %{epoch}:%{version}-%{release}
Obsoletes: %{short_name} < %{epoch}:%{version}-%{release}

%description
The Modeler project shall create and maintain a set of Java
classes to provide the facilities described in the preceeding section, plus
unit tests and small examples of using these facilities to instrument
Java classes with Model MBean support.

%if %{with_repolib}
%package	 repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	Development/Libraries/Java

%description	 repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%package javadoc
Summary: Javadoc for %{name}
Group: Development/Documentation
Requires(post): /bin/rm
Requires(post): /bin/ln 
Requires(postun): /bin/rm

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n %{short_name}-%{version}-src
%patch0
%patch1  
# remove all binary files
find . \( -name "*.jar" -o -name "*.class" -o -name "*.zip" \) \
    | xargs %{__rm} -f


# fix eol encodings
%{__sed} -i 's/\r//' xdocs/downloads.xml
%{__sed} -i 's/\r//' xdocs/cvs-usage.xml
%{__sed} -i 's/\r//' xdocs/issue-tracking.xml
%{__sed} -i 's/\r//' LICENSE.txt
%{__sed} -i 's/\r//' xdocs/navigation.xml
%{__sed} -i 's/\r//' xdocs/style/project.css
%{__sed} -i 's/\r//' xdocs/index.xml
%{__sed} -i 's/\r//' xdocs/building.xml
%{__sed} -i 's/\r//' NOTICE.txt
%{__sed} -i 's/\r//' RELEASE-NOTES.txt

jar cf %{short_name}-src.jar -C src/java/ .

tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE1}

%build
export CLASSPATH=$(build-classpath xml-commons-apis jaxp_parser_impl jaxp_transform_impl jmxri junit commons-beanutils commons-collections commons-digester commons-logging)
%{ant} dist

%install
%{__rm} -rf %{buildroot}
# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -a dist/%{short_name}.jar \
    %{buildroot}%{_javadir}/%{name}-%{version}.jar
(
    cd %{buildroot}%{_javadir}
    for jar in *-%{version}*; do
        %{__ln_s} ${jar} `echo $jar | %{__sed} "s|jakarta-||g"`
    done
)
(
    cd %{buildroot}%{_javadir}
    for jar in *-%{version}*; do
        %{__ln_s} ${jar} `echo $jar | %__sed "s|-%{version}||g"`
    done
)
# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__cp} -a dist/docs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
(
    cd %{buildroot}%{_javadocdir}
    %{__ln_s} %{name}-%{version} %{name}
)
%if %{gcj_support}
    %{_bindir}/aot-compile-rpm
%endif


%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{PATCH1} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	cp $RPM_BUILD_ROOT%{_javadir}/commons-modeler.jar $RPM_BUILD_ROOT%{repodirlib}
	cp %{short_name}-src.jar $RPM_BUILD_ROOT%{repodirlib}
	cp %{short_name}-src.jar $RPM_BUILD_ROOT%{repodirsrc}
%endif

%clean
%{__rm} -rf %{buildroot}

%post javadoc
%{__rm} -f %{_javadocdir}/%{name}
%{__ln_s} %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ $1 -eq 0 ]; then
    %{__rm} -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]; then
    %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]; then
    %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc LICENSE.txt NOTICE.txt RELEASE-NOTES.txt xdocs
%{_javadir}/*

%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/%{name}-%{version}.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%dir %{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}-%{version}/*
%ghost %dir %{_javadocdir}/%{name}


%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif

%changelog
* Fri Apr 27 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.0-3jpp_2rh
- Actually disable repolib by default

* Fri Apr 27 2007 Vivek Lakshmanan <vivekl@redhat.com> - 0:2.0-3jpp_1rh
- Upgrade to 2.0
- Add repolib support (disabled by default) for shipping to JBoss

* Wed Mar 21 2007 Matt Wringe <mwringe@redhat.com> - 0:2.0-3jpp
- Make provides and obsoletes versioned
- Fix eol encoding on various files

* Tue Mar 12 2007 Jason Corley <jason.corley@gmail.com> - 0:2.0-2jpp
- respin to upload to main repo
- fix rpmlint warnings

* Tue Feb 27 2007 Jason Corley <jason.corley@gmail.com> - 0:2.0-1jpp
- change copyright text to have current year
- minor aesthetic cleanups
- update to 2.0

* Thu Aug 10 2006 Matt Wringe <mwringe at redhat.com> - 0:1.1-8jpp
- Add missing javadoc requires
- Add patches to properly set the classpath in build.xml and 
  build.properties.default

* Wed Jul 19 2006 Matt Wringe <mwringe at redhat.com> - 0:1.1-7jpp
- Removed separate definition of name, version and release

* Mon Jul 17 2006 Matt Wringe <mwringe at redhat.com> - 0:1.1-6jpp
- Added contional native compilation.

* Wed Apr 26 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.1-5jpp
- First JPP 1.7 build

* Thu Feb 24 2005 David Walluck <david@jpackage.org> 0:1.1-4jpp
- add missing epochs to dependencies
- add non-versioned javadoc symlink
- fix file permissions

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:1.1-3jpp
- Rebuild with ant-1.6.2
* Thu Oct 09 2003 Henri Gomez <hgomez at users.sourceforge.net> 0:1.1-2jpp
- fix junit typo (reported by Kaj J. Niemi)

* Wed Oct 08 2003 Henri Gomez <hgomez at users.sourceforge.net> 0:1.1-1jpp
- modeler 1.1

* Tue Mar 25 2003 Nicolas Mailhot <Nicolas.Mailhot (at) JPackage.org> 1.0-6jpp
- for jpackage-utils 1.5

* Thu Feb 27 2003 Henri Gomez <hgomez@users.sourceforge.net> 1.0-5jpp
- fix ASF license

* Thu Feb 27 2003 Henri Gomez <hgomez@users.sourceforge.net> 1.0-4jpp
- fix missing packager tag
- fix new mx4j jar name (mx4j-jmx.jar)

* Fri Jul 12 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0-3jpp
- updated requires for jaxp_parser_impl and xml-commons-apis

* Mon Jun 10 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0-2jpp
- use sed instead of bash 2.x extension in link area to make spec compatible
  with distro using bash 1.1x

* Fri Jun 07 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0-1jpp 
- 1.0
- added short names in %%{_javadir}, as does jakarta developpers
- first jPackage release
